function [mag_500, mag_1000, mag_2000, mag_4000] = BP_magnitude(angle, IR, fs, onset, release);

angle_radians = angle/(2*pi);

f0 = 250;
F = [0:1/4195:1]*fs/2;

for i = 1:4
    
    f = f0*2^i;
    f1 = (f*2^(1/2))/(fs/2);
    if f1 > 1
        f1 = 0.99999;
    end;
    f2 = (f*2^(-1/2))/(fs/2);
    [B A] = butter(2, [f1 f2]);
    [h w] = freqz(B, A, F, fs);
    IR_bp(:,i) = filter(fliplr(B), fliplr(A), IR);

end;

%This can be used to hard code onset and release values.
%
%release = round(0.005*fs); %how long to look after the peak (5 ms) in samples
%onset = round(0.001*fs); %how long to look before the peak (1 ms) in samples

theta_500 = IR_bp(:,1);
theta_1000 = IR_bp(:,2);
theta_2000 = IR_bp(:,3);
theta_4000 = IR_bp(:,4);
[y, max_index] = max(theta_500);

theta_500 = theta_500(round(max_index - onset): round(max_index + release));
[y, max_index] = max(theta_1000);
theta_1000 = theta_1000(round(max_index - onset): round(max_index + release));
[y, max_index] = max(theta_2000);
theta_2000 = theta_2000(round(max_index - onset): round(max_index + release));
[y, max_index] = max(theta_4000);
theta_4000 = theta_4000(round(max_index - onset): round(max_index + release));

mag_500 = sqrt(sum(theta_500.^2,1));% avg energy: /length(theta_500)
mag_1000 = sqrt(sum(theta_1000.^2,1));
mag_2000 = sqrt(sum(theta_2000.^2,1));
mag_4000 = sqrt(sum(theta_4000.^2,1));
