function varargout = RJ_test_system_v1(varargin)
% RJ_TEST_SYSTEM_V1 M-file for RJ_test_system_v1.fig
%      RJ_TEST_SYSTEM_V1, by itself, creates a new RJ_TEST_SYSTEM_V1 or raises the existing
%      singleton*.
%
%      H = RJ_TEST_SYSTEM_V1 returns the handle to a new RJ_TEST_SYSTEM_V1 or the handle to
%      the existing singleton*.
%
%      RJ_TEST_SYSTEM_V1('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RJ_TEST_SYSTEM_V1.M with the given input arguments.
%
%      RJ_TEST_SYSTEM_V1('Property','Value',...) creates a new RJ_TEST_SYSTEM_V1 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before RJ_test_system_v1_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to RJ_test_system_v1_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help RJ_test_system_v1

% Last Modified by GUIDE v2.5 30-Jun-2009 19:56:08

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @RJ_test_system_v1_OpeningFcn, ...
                   'gui_OutputFcn',  @RJ_test_system_v1_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT




% --- Executes just before RJ_test_system_v1 is made visible.
function RJ_test_system_v1_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to RJ_test_system_v1 (see VARARGIN)

% Choose default command line output for RJ_test_system_v1
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes RJ_test_system_v1 wait for user response (see UIRESUME)
% uiwait(handles.figure1);
global fs;
global g_num_channels;
global g_ms;
global sweepOrPulse;
global sweep_scale;
global g_SweepTime;
global g_num_sweeps;
global g_mirror_90;
global g_mirror_180;
global g_hw_mode;
global g_input_device;
global g_output_device;
global g_write_wav;

fs = 44100;
g_num_channels = 1;
g_ms = 0;
sweepOrPulse = 'sweep';
sweep_scale = 'log';
g_SweepTime = 1;
g_num_sweeps = 1;
g_mirror_90 = 0;
g_mirror_180 = 0;
g_hw_mode = 'dx';
g_input_device = 1;
g_output_device = 0;
g_write_wav = 0;


% --- Outputs from this function are returned to the command line.
function varargout = RJ_test_system_v1_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in make_it_happen.
function make_it_happen_Callback(hObject, eventdata, handles)
% hObject    handle to make_it_happen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global fs;
global sweep_scale;
global sweepOrPulse;
global GolaySize;
global GolayPause;
global g_SweepTime;
global g_num_sweeps;
global AP_n;
global g_num_channels;
global g_hw_mode;
global g_input_device;
global g_output_device;


switch sweepOrPulse
    case 'sweep',
        set(handles.P_IR_graph, 'Visible', 'on');
        set(handles.P_golay_A, 'Visible', 'off' );
        set(handles.P_golay_B, 'Visible', 'off' );
        set(handles.robert_golay, 'Visible', 'off');
        cla(handles.P_golay_A);
        cla(handles.P_golay_B);
        [X abins] = sweep(g_SweepTime, sweep_scale, 44100, g_num_sweeps);
        response = get_response(X, fs, g_num_channels, g_hw_mode, g_input_device, g_output_device);
        response = response(end-abins+1:end);
        X = X(end-abins+1:end)';
        
        IR = real(ifft(fft(response)./fft(X)));
        [avg_energy t60 fit_range linear_fit] = t60_calc(IR, fs);
        set(handles.t60_display, 'Visible', 'on');
        set(handles.t60_display, 'String', ['t60 = ' num2str(t60) ' seconds.']);
        
        
        axes(handles.P_IR_graph);
        cla(handles.P_IR_graph);
        hold on;
        xlim([0 (abins)/abins]);
        plot([0:abins-1]/abins, db(IR), 'Color', [0.6 0.6 0.6]); %not 0:abins-1 because of the leading 0
        plot([0:abins-1]/abins, db(avg_energy), 'Color', 'black');
        plot(fit_range/abins, db(abs(avg_energy(fit_range))), 'Color', 'green');
        plot(fit_range/abins, linear_fit(1)*fit_range + linear_fit(2), 'Color', 'red');
        hold off;
        %axis off;
        xlabel('dB');
        
        axes(handles.P_spec_graph);
        cla(handles.P_spec_graph);
        %specgram(IR); colorbar;
        spectrogram(IR, Hann(256), 128, 'yaxis'); colorbar;
        ylabel('Freq (radians)');
        xlabel('Time (samples)');
        
        
        freq_bins = 4028;
        fstep = fs / (2*freq_bins);
        x = fs/2 * linspace(0, 1, freq_bins);
        window_length = freq_bins / 128; %bins
        window = ones(window_length, 1) / window_length;
        H = real(fft(IR, 2*freq_bins));
        %cheap average by convolution with averaged rectangular window (hop size = 1 bin)   
        avg_energy = sqrt(fftfilt(window, H.^2));
%       avg_energy = cbsmooth_bark(H, 1, fs);
        avg_energy = db(avg_energy);
        H = db(H);
        axes(handles.P_freq_response);
        cla(handles.P_freq_response);
        axis on;
        hold on;
        semilogx(x, H(1:freq_bins), 'Color', [0.6 0.6 0.6]);
        semilogx(x, avg_energy(1:freq_bins), 'Color', 'k');
        hold off;
        xlim([20 20000]);
        xlabel('frequency (Hz)');
        ylabel('dB');
       
        
    case 'golay',
        %TODO: fix IR calculation
        set(handles.P_IR_graph, 'Visible', 'on');
        set(handles.P_freq_response, 'Visible', 'off');
        set(handles.P_golay_A, 'Visible', 'on' );
        set(handles.P_golay_B, 'Visible', 'on' );
        set(handles.robert_golay, 'Visible', 'on');
        set(handles.t60_display, 'Visible', 'off');
        axes(handles.robert_golay);
        axis off;
        
        [a b] = golay(GolaySize, fs);
        pause_time_samp = GolayPause * fs;
        responseA = get_response([a zeros(1, pause_time_samp)], fs, g_num_channels, g_hw_mode, g_input_device, g_output_device);
        pause on;
        pause(GolayPause)
        responseB = get_response([b zeros(1, pause_time_samp)], fs, g_num_channels, g_hw_mode, g_input_device, g_output_device);
        Golay_IR = convolve_golay(a, responseA, b, responseB);
        [avg_energy t60 fit_range linear_fit] = t60_calc(Golay_IR, fs);
        figure(2); plot(Golay_IR);
        
        axes(handles.P_golay_A);
        cla(handles.P_golay_A);
        plot((2^GolaySize)-GolaySize:1:(2^GolaySize), a(end-GolaySize:end));
        xlim([(2^GolaySize)-GolaySize, 2^GolaySize]);
        ylabel('Golay A');
        set(handles.P_golay_A, 'Xcolor', [.8 .8 .8]);
 
        axes(handles.P_golay_B);
        cla(handles.P_golay_B);
        plot((2^GolaySize)-GolaySize:1:(2^GolaySize), b(end-GolaySize:end));
        xlim([(2^GolaySize)-GolaySize, 2^GolaySize]);
        ylabel('Golay B');
        xlabel(['Golay: last ' num2str(GolaySize) ' samples']);
        
        axes(handles.P_IR_graph);
        cla(handles.P_IR_graph);
        freq_bins = 4028;
        fstep = fs / (2*freq_bins);
        x = fs/2 * linspace(0, 1, freq_bins);
        window_length = freq_bins / 128; %bins
        window = ones(window_length, 1) / window_length;
        Golay_fft = real(fft(Golay_IR, 2*freq_bins));
        avg_energy = sqrt(fftfilt(window, Golay_fft.^2));
        hold on;
        plot(x,db(Golay_fft(1:freq_bins)), 'Color', [0.6 0.6 0.6]);
        plot(x,db(avg_energy(1:freq_bins)), 'Color', 'k');
        hold off;
        ylabel('dB');
        
        axes(handles.P_spec_graph);
        cla(handles.P_spec_graph);
        spectrogram(Golay_IR, Hann(256), 128, 'yaxis'); colorbar;
        ylabel('Freq (radians)');
        xlabel('Time (samples)');
        
    case 'allpass',
        disp(['doin the allpass dance']);
        disp(['n = ' num2str(AP_n)]);
        set(handles.t60_display, 'Visible', 'off');
        minRho = calibrate_allpass(AP_n);
        AP_signal = generate_allpass(AP_n, minRho);
        disp(minRho);
        figure;
        plot(AP_signal);
        AP_response = get_response(AP_signal, fs, g_num_channels, g_hw_mode, g_input_device, g_output_device);
        IR = fftfilt(AP_response, AP_signal);
        
    otherwise 
        disp('uh....mmmm....what??');
end;

 
% --- Executes on button press in stop_button.
function stop_button_Callback(hObject, eventdata, handles)
% hObject    handle to stop_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
disp('');
disp('       and remember...');
disp('');
disp('    Ron Jeremy Loves you!');
disp('');
disp('--------- KISSES!!!! ---------');
close(handles.figure1);


% % --- Executes during object creation, after setting all properties.
% function make_it_happen_CreateFcn(hObject, eventdata, handles)
% % hObject    handle to make_it_happen (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function logo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to logo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate logo
axes(hObject)
imshow('jeremy.jpg');


% --- Executes on button press in Linear_bool.
function Linear_bool_Callback(hObject, eventdata, handles)
% hObject    handle to Linear_bool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Linear_bool
   global sweep_scale 
   sweep_scale = 'linear'
   global sweepOrPulse;
   sweepOrPulse = 'sweep';
   cla(handles.robert_golay);
   set(handles.golay_input_label, 'Visible', 'off');
   set(handles.sweep_length_label, 'Visible', 'on');
   set(handles.golay_size, 'Visible', 'on');
   set(handles.num_sweeps_label, 'Visible', 'on');
   set(handles.num_sweeps_input, 'Visible', 'on');
   set(handles.Golay_pause_label, 'Visible', 'off');
  

% --- Executes on button press in log_bool.
function log_bool_Callback(hObject, eventdata, handles)
% hObject    handle to log_bool (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of log_bool
   global sweep_scale 
   sweep_scale = 'log'
   global sweepOrPulse;
   sweepOrPulse = 'sweep';
   cla(handles.robert_golay);
   set(handles.golay_size, 'Visible', 'on');
   set(handles.golay_input_label, 'Visible', 'off');
   set(handles.sweep_length_label, 'Visible', 'on');
   set(handles.num_sweeps_label, 'Visible', 'on');
   set(handles.num_sweeps_input, 'Visible', 'on');
   set(handles.allpass_order_label, 'Visible', 'off');
   set(handles.Golay_pause_label, 'Visible', 'off');


% --- Executes on button press in Golay_select.
function Golay_select_Callback(hObject, eventdata, handles)
% hObject    handle to Golay_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Golay_select
global sweepOrPulse;
sweepOrPulse = 'golay';
axes(handles.robert_golay);
imshow('goulet.jpg');
axis off;
set(handles.golay_input_label, 'Visible', 'on');
set(handles.golay_size, 'Visible', 'on');
set(handles.sweep_length_label, 'Visible', 'off');
set(handles.num_sweeps_label, 'Visible', 'off');
set(handles.num_sweeps_input, 'Visible', 'on');
set(handles.Golay_pause_label, 'Visible', 'on');
set(handles.allpass_order_label, 'Visible', 'off');

% --- Executes on button press in allpass_select.
function allpass_select_Callback(hObject, eventdata, handles)
% hObject    handle to allpass_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of allpass_select

%make this text box give different values for the the different scales
% (between duration and golay length)
global sweepOrPulse;
sweepOrPulse = 'allpass';

set(handles.golay_input_label, 'Visible', 'off');
set(handles.golay_size, 'Visible', 'on');
set(handles.sweep_length_label, 'Visible', 'off');
set(handles.num_sweeps_label, 'Visible', 'off');
set(handles.num_sweeps_input, 'Visible', 'off');
cla(handles.robert_golay);
set(handles.allpass_order_label, 'Visible', 'on');
set(handles.Golay_pause_label, 'Visible', 'off');


function golay_size_Callback(hObject, eventdata, handles)
% hObject    handle to golay_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of golay_size as text
%        str2double(get(hObject,'String')) returns contents of golay_size as a double
global GolaySize;
global g_SweepTime;
global sweepOrPulse;
global AP_n;
switch sweepOrPulse
    
    case 'golay',
        GolaySize = str2double(get(hObject,'String'));
    case 'sweep',
        g_SweepTime = str2double(get(hObject,'String'));
    case 'allpass',
        AP_n = str2double(get(hObject,'String'));
end;        
            
%make this text box give different values for the the different scales
% (between duration and golay length)

% --- Executes during object creation, after setting all properties.
function golay_size_CreateFcn(hObject, eventdata, handles)
% hObject    handle to golay_size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white figure1 on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function num_sweeps_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_sweeps_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function num_sweeps_input_Callback(hObject, eventdata, handles)
% hObject    handle to num_sweeps_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of num_sweeps_input as text
%        str2double(get(hObject,'String')) returns contents of num_sweeps_input as a double
global g_num_sweeps;
global GolayPause;
global sweepOrPulse;
disp('num sweeps, here');
switch sweepOrPulse
    case 'golay',
        GolayPause = str2double(get(hObject,'String'))
    case 'sweep',
        g_num_sweeps = str2double(get(hObject,'String'));
end



% --- Executes on selection change in fs_in.
function fs_in_Callback(hObject, eventdata, handles)
% hObject    handle to fs_in (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns fs_in contents as cell array
%        contents{get(hObject,'Value')} returns selected item from fs_in
global fs;
selection = [get(hObject,'Value')];
switch selection
    case 1,
        fs = 44100;
        disp(['Sample Rate set at' num2str(fs) ' samples / sec']);
    case 2,
        fs = 48000;
        disp(['Sample Rate set at' num2str(fs) ' samples / sec']);
    case 3,
        fs = 96000;
        disp(['Sample Rate set at' num2str(fs) ' samples / sec']);
    case 4
        fs = 192000;
        disp(['Sample Rate set at' num2str(fs) ' samples / sec']);
    otherwise
        disp('howd that happen?');  
    
end;

% --- Executes during object creation, after setting all properties.
function fs_in_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fs_in (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function end_degree_Callback(hObject, eventdata, handles)
% hObject    handle to g_end_degree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of g_end_degree as text
%        str2double(get(hObject,'String')) returns contents of g_end_degree as a double
global g_end_degree;
g_end_degree = str2double(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function end_degree_CreateFcn(hObject, eventdata, handles)
% hObject    handle to g_end_degree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function degree_increment_Callback(hObject, eventdata, handles)
% hObject    handle to g_degree_increment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of g_degree_increment as text
%        str2double(get(hObject,'String')) returns contents of g_degree_increment as a double
global g_degree_increment;
g_degree_increment = str2double(get(hObject,'String'));


% --- Executes during object creation, after setting all properties.
function degree_increment_CreateFcn(hObject, eventdata, handles)
% hObject    handle to g_degree_increment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in go_polar.
function go_polar_Callback(hObject, eventdata, handles)
% hObject    handle to go_polar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global fs;
global g_end_degree;
global g_degree_increment;
global g_num_sweeps;
global g_mirror_180;
global g_mirror_90;
global g_ms;
global g_num_channels;
global g_hw_mode;
global g_input_device;
global g_output_device;
global g_write_wav;

mirror = 0;
if g_mirror_180 || g_mirror_90
    mirror = 1;
end;
make_polar_response(fs, g_end_degree, g_degree_increment, mirror, g_ms, g_num_sweeps, g_num_channels, g_hw_mode, g_input_device, g_output_device, g_write_wav);

% --- Executes during object creation, after setting all properties.
function mirror_180_select_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mirror_180_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(hObject,'Value', 0)

% --- Executes on button press in mirror_180_select.
function mirror_180_select_Callback(hObject, eventdata, handles)
% hObject    handle to mirror_180_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of mirror_180_select
global g_mirror_180;
global g_end_degree;
g_mirror_180 = get(hObject,'Value');
if g_mirror_180
    g_end_degree = 180;
    disp('end degree changed to 180');
end;

% --- Executes during object creation, after setting all properties.
function mirror_90_select_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mirror_90_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(hObject,'Value', 0)

% --- Executes on button press in mirror_90_select.
function mirror_90_select_Callback(hObject, eventdata, handles)
% hObject    handle to mirror_90_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of mirror_90_select
global g_mirror_90;
global g_end_degree;

g_mirror_90 = get(hObject,'Value');
if g_mirror_90
    g_end_degree = 90;
    disp('end degree changed to 90');
end;


% --- Executes on button press in ms_select.
function ms_select_Callback(hObject, eventdata, handles)
% hObject    handle to ms_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ms_select
global g_ms;
g_ms = 1;

% --- Executes on button press in stereo_select.
function stereo_select_Callback(hObject, eventdata, handles)
% hObject    handle to stereo_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of stereo_select
global g_num_channels;
state = get(hObject,'Value');
if state
    g_num_channels = 2;
else
    g_num_channels = 1;
end


% --- Executes on button press in sweep_twice_button.
function sweep_twice_button_Callback(hObject, eventdata, handles)
% hObject    handle to sweep_twice_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sweep_twice_button
global g_num_sweeps;
g_num_sweeps = 2;


% --- Executes on button press in sweep_once_button.
function sweep_once_button_Callback(hObject, eventdata, handles)
% hObject    handle to sweep_once_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sweep_once_button
global g_num_sweeps;
g_num_sweeps = 1;


% --- Executes during object creation, after setting all properties.
function sweep_once_button_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sweep_once_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(hObject,'Value', 1)


function output_device_input_Callback(hObject, eventdata, handles)
% hObject    handle to output_device_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of output_device_input as text
%        str2double(get(hObject,'String')) returns contents of output_device_input as a double
global g_output_device;
g_output_device = round(str2num(get(hObject,'String')))

% --- Executes during object creation, after setting all properties.
function output_device_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to output_device_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function input_device_input_Callback(hObject, eventdata, handles)
% hObject    handle to input_device_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of input_device_input as text
%        str2double(get(hObject,'String')) returns contents of input_device_input as a double
global g_input_device;
g_input_device = round(str2num(get(hObject,'String')))



% --- Executes during object creation, after setting all properties.
function input_device_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to input_device_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in dx_select.
function dx_select_Callback(hObject, eventdata, handles)
% hObject    handle to dx_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of dx_select
global g_hw_mode;
g_hw_mode = 'dx';


% --- Executes on button press in asio_select.
function asio_select_Callback(hObject, eventdata, handles)
% hObject    handle to asio_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of asio_select
global g_hw_mode;
g_hw_mode = 'asio';

% --- Executes on button press in Open_Hardware_setup.
function Open_Hardware_setup_Callback(hObject, eventdata, handles)
% hObject    handle to Open_Hardware_setup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Open_Hardware_setup
global g_hw_mode;
disp('');
pa_wavplayrecord(g_hw_mode);


% --- Executes on button press in save_waves_input.
function save_waves_input_Callback(hObject, eventdata, handles)
% hObject    handle to save_waves_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of save_waves_input
global g_write_wav;
if get(hObject, 'Value')
    g_write_wav = 1;
    disp('IRs will be written to wav files');
else
    g_write_wav = 0;
    disp('IRs will not be written to wav files');
end;


% --- Executes during object creation, after setting all properties.
function polar_pause_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to polar_pause_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
