function make_polar_response (fs, end_degree, interval, mirror, ms, num_sweeps, num_channels, g_hw_mode, g_input_device, g_output_device, write_wav)
% clear t_rad; 
% clear mag_500_vector;
% clear mag_4000_vector;
% fs = 44100;
% end_degree = 360;
% interval = 90;
num_channels
end_degree
interval
mirror
write_wav

x1=0; x2=0;x_axis1=0;x_axis2=0;onset=0;release=0;
x1L=0; x2L=0;x_axis1L=0;x_axis2L=0;onsetL=0;releaseL=0;
x1R=0; x2R=0;x_axis1R=0;x_axis2R=0;onsetR=0;releaseR=0;

h = waitbar(0, 'Press any key to begin');
t_rad = 0;
index_end = round(end_degree / interval);
if num_channels == 1
    mag_500_vector = zeros(1, index_end);
    mag_1000_vector = zeros(1, index_end);
    mag_2000_vector = zeros(1, index_end);
    mag_4000_vector = zeros(1, index_end);

elseif num_channels == 2
    mag_500_vectorL = zeros(1, index_end);
    mag_1000_vectorL = zeros(1, index_end);
    mag_2000_vectorL = zeros(1, index_end);
    mag_4000_vectorL = zeros(1, index_end);
    
    mag_500_vectorR = zeros(1, index_end);
    mag_1000_vectorR = zeros(1, index_end);
    mag_2000_vectorR = zeros(1, index_end);
    mag_4000_vectorR = zeros(1, index_end);
end

for i = 0:index_end
    figure(h);
    waitbar((i)/(index_end+1), h);
    if i == 0;
        title('Press any key to begin');

    else
    %title(['Angle: ' num2str(i*interval) ' degrees. ' num2str(100*i/index_end) '% complete ']);
        title(sprintf('Set angle to %3.0f degrees. %3.0f%% complete \nPress any key to continue...', i*interval, 100*(i)/(index_end+1)));
    end;
    pause
    
    theta_radians = i*interval*pi/180;
    [signal abins] = sweep(1, 'log', fs, num_sweeps);
    response = get_response(signal, fs, num_channels, g_hw_mode, g_input_device, g_output_device);
    signal = signal(end-abins+1:end)';
    
    if num_channels == 1;
        response = response(end-abins+1:end);
        IR = real(ifft(fft(response)./fft(signal)));
        if write_wav
            wavwrite(IR*200, fs, 16, ['ir', int2str(i), '.wav']);
        end;
        if i == 0
            [y_max i_max] = max(IR);
            ir_fig = figure;
            hold on;
            plot(IR, 'Color', [0.6 0.6 0.6]);
            plot(i_max, y_max, 'o', 'Color','r');
            hold off;
            title('Pick 2 points on x-axis to zoom for direct path determination');
            xlabel('time (samples)');
            [x_axis y_axis] = ginput(2);
            x_axis1 = round(x_axis(1));
            x_axis2 = round(x_axis(2));
            if x_axis1 > x_axis2
                x_temp = x_axis2;
                x_axis2 = x_axis1;
                x_axis1 = x_temp;
            end;
            
            figure(clf(ir_fig));
            
            hold on;
            plot(x_axis1:x_axis2, IR(x_axis1:x_axis2), 'Color',[0.6 0.6 0.6]);
            plot(i_max, y_max, 'o', 'Color','r');
            xlabel('time (samples)');
            title('Pick points to measure IR direct path');
            hold off;
            [x y] = ginput(2);
            x1 = round(x(1));
            x2 = round(x(2));
            if x1 > x2
                x_temp = x2;
                x2 = x1;
                x1 = x_temp;
            end;
            onset = abs(x1-i_max);
            release = abs(x2-i_max);
        end;

        figure(clf(ir_fig))
%         ir_fig = figure;
        [IR_y IR_max] = max(IR);
        hold on;
        plot(x_axis1:x_axis2, IR(x_axis1:x_axis2), 'Color',[0.6 0.6 0.6]);
        plot(IR_max - onset:IR_max + release, IR(IR_max - onset:IR_max + release), 'Color', 'k');
        plot(IR_max, IR_y, 'o', 'Color', 'r');
        title('IR with selected direct path');
        hold off;
        
        absolute_onset = IR_max - onset;
        absolute_release = IR_max + release;
        [mag_500, mag_1000, mag_2000, mag_4000] = BP_magnitude(theta_radians, IR, fs, absolute_onset, absolute_release);
        mag_500_vector(i+1) = mag_500;
        mag_1000_vector(i+1) =  mag_1000;
        mag_2000_vector(i+1) = mag_2000;
        mag_4000_vector(i+1) = mag_4000;
        
    elseif num_channels == 2;
        responseL = response(:,1);
        responseR = response(:,2);
        responseL = responseL(end-abins+1:end);
        responseR = responseR(end-abins+1:end);
        
        if ms == 1;
            responseL = (responseL + responseR)./2;
            responseR = (responseL - responseR)./2;
        end
        
        IR_L = real(ifft(fft(responseL)./fft(signal)));
        IR_R = real(ifft(fft(responseR)./fft(signal)));
        if write_wav
            wavwrite(IR_L*200, fs, 16, ['irL', int2str(i), '.wav']);
            wavwrite(IR_R*200, fs, 16, ['irR', int2str(i), '.wav']);
        end;
        
        if i == 0
            %--------------------------------------------------------------
            %Left Channel:
            [y_max i_max] = max(IR_L);
            ir_figL = figure;
            hold on;
            plot(IR_L, 'Color', [0.6 0.6 0.6]);
            plot(i_max, y_max, 'o', 'Color','r');
            hold off;
            title('LEFT: Pick 2 points on x-axis to zoom for direct path determination');
            xlabel('time (samples)');
            [x_axisL y_axisL] = ginput(2);
            x_axis1L = round(x_axisL(1));
            x_axis2L = round(x_axisL(2));
            if x_axis1L > x_axis2L
                x_temp = x_axis2L;
                x_axis2L = x_axis1L;
                x_axis1L = x_temp;
            end;

            figure(clf(ir_figL));
            
            hold on;
            plot(x_axis1L:x_axis2L, IR_L(x_axis1L:x_axis2L), 'Color',[0.6 0.6 0.6]);
            plot(i_max, y_max, 'o', 'Color','r');
            xlabel('time (samples)');
            title('LEFT: Pick points to measure IR direct path');
            hold off;
            [x y] = ginput(2);
            x1L = round(x(1));
            x2L = round(x(2));
            if x1L > x2L
                x_temp = x2L;
                x2L = x1L;
                x1L = x_temp;
            end;
            onsetL = abs(x1L-i_max);
            releaseL = abs(x2L-i_max);
            %--------------------------------------------------------------
            %Right Channel:
            [y_max i_max] = max(IR_R);
            ir_figR = figure;
            hold on;
            plot(IR_R, 'Color', [0.6 0.6 0.6]);
            plot(i_max, y_max, 'o', 'Color','r');
            hold off;
            title('RIGHT: Pick 2 points on x-axis to zoom for direct path determination');
            xlabel('time (samples)');
            [x_axisR y_axisR] = ginput(2);
            x_axis1R = round(x_axisR(1));
            x_axis2R = round(x_axisR(2));
            if x_axis1R > x_axis2R
                x_temp = x_axis2R;
                x_axis2R = x_axis1R;
                x_axis1R = x_temp;
            end;
            
            figure(clf(ir_figR));
            
            hold on;
            plot(x_axis1R:x_axis2R, IR_R(x_axis1R:x_axis2R), 'Color',[0.6 0.6 0.6]);
            plot(i_max, y_max, 'o', 'Color','r');
            xlabel('time (samples)');
            title('RIGHT: Pick points to measure IR direct path');
            hold off;
            [x y] = ginput(2);
            x1R = round(x(1));
            x2R = round(x(2));
            if x1R > x2R
                x_temp = x2R;
                x2R = x1R;
                x1R = x_temp;
            end;
            onsetR = abs(x1R-i_max);
            releaseR = abs(x2R-i_max);
        
        end;
        
        
        figure(clf(ir_figL));
        [IR_y IR_max] = max(IR_L);
        hold on;
        plot(x_axis1L:x_axis2L, IR_L(x_axis1L:x_axis2L), 'Color',[0.6 0.6 0.6]);
        plot(IR_max - onsetL:IR_max + releaseL, IR_L(IR_max - onsetL:IR_max + releaseL), 'Color', 'k');
        plot(IR_max, IR_y, 'o', 'Color', 'r');
        title('LEFT: IR with selected direct path');
        hold off;
        
        absolute_onsetL = IR_max - onsetL;
        absolute_releaseL = IR_max + releaseL;
        
        figure(clf(ir_figR));
        [IR_y IR_max] = max(IR_R);
        hold on;
        plot(x_axis1R:x_axis2R, IR_R(x_axis1R:x_axis2R), 'Color',[0.6 0.6 0.6]);
        plot(IR_max - onsetR:IR_max + releaseR, IR_R(IR_max - onsetR:IR_max + releaseR), 'Color', 'k');
        plot(IR_max, IR_y, 'o', 'Color', 'r');
        title('RIGHT: IR with selected direct path');
        hold off;
        
        absolute_onsetR = IR_max - onsetR;
        absolute_releaseR = IR_max + releaseR;
        
        [mag_500L, mag_1000L, mag_2000L, mag_4000L] = BP_magnitude(theta_radians, IR_L, fs, absolute_onsetL, absolute_releaseL);
        [mag_500R, mag_1000R, mag_2000R, mag_4000R] = BP_magnitude(theta_radians, IR_R, fs, absolute_onsetR, absolute_releaseR);
        
        mag_500_vectorL(i+1) = mag_500L;
        mag_1000_vectorL(i+1) =  mag_1000L;
        mag_2000_vectorL(i+1) = mag_2000L;
        mag_4000_vectorL(i+1) = mag_4000L;
                
        mag_500_vectorR(i+1) = mag_500R;
        mag_1000_vectorR(i+1) =  mag_1000R;
        mag_2000_vectorR(i+1) = mag_2000R;
        mag_4000_vectorR(i+1) = mag_4000R;
    end;

    t_rad(i+1) = theta_radians;

end;

delete(h);
if num_channels == 1
    close(ir_fig);
elseif num_channels == 2
    close(ir_figL);
    close(ir_figR);
end;

if mirror && end_degree == 180 && num_channels == 1
    disp('mirrored about 180 degrees');
    mag_500_vector = [mag_500_vector fliplr(mag_500_vector)];
    mag_1000_vector = [mag_1000_vector fliplr(mag_1000_vector)];
    mag_2000_vector = [mag_2000_vector fliplr(mag_2000_vector)];
    mag_4000_vector = [mag_4000_vector fliplr(mag_4000_vector)];
    t_rad_theRest = t_rad + index_end*interval*pi/180;
    t_rad = [t_rad t_rad_theRest];

elseif mirror && end_degree == 90 && num_channels == 1
    disp('mirrored about 90 degrees');
    mag_500_vector = [mag_500_vector fliplr(mag_500_vector) 
        fliplr([mag_500_vector fliplr(mag_500_vector)])];
    mag_1000_vector = [mag_1000_vector fliplr(mag_1000_vector)
        fliplr([mag_1000_vector fliplr(mag_1000_vector)])];
    mag_2000_vector = [mag_2000_vector fliplr(mag_2000_vector)
        fliplr([mag_2000_vector fliplr(mag_2000_vector)])];
    mag_4000_vector = [mag_4000_vector fliplr(mag_4000_vector)
         fliplr([mag_4000_vector fliplr(mag_4000_vector)])];
    t_rad_theRest1 = t_rad + index_end*interval*pi/180;
    t_rad_theRest2 = t_rad + 2*index_end*interval*pi/180;
    t_rad_theRest3 = t_rad + 3*index_end*interval*pi/180;
    t_rad = [t_rad t_rad_theRest1 t_rad_theRest2 t_rad_theRest3];
    
elseif mirror && end_degree == 180 && num_channels == 2
    disp('mirrored about 180 degrees');
    mag_500_vectorL = [mag_500_vectorL fliplr(mag_500_vectorL)];
    mag_1000_vectorL = [mag_1000_vectorL fliplr(mag_1000_vectorL)];
    mag_2000_vectorL = [mag_2000_vectorL fliplr(mag_2000_vectorL)];
    mag_4000_vectorL = [mag_4000_vectorL fliplr(mag_4000_vectorL)];
    
    mag_500_vectorR = [mag_500_vectorR fliplr(mag_500_vectorR)];
    mag_1000_vectorR = [mag_1000_vectorR fliplr(mag_1000_vectorR)];
    mag_2000_vectorR = [mag_2000_vectorR fliplr(mag_2000_vectorR)];
    mag_4000_vectorR = [mag_4000_vectorR fliplr(mag_4000_vectorR)];
    
    t_rad_theRest = t_rad + index_end*interval*pi/180;
    t_rad = [t_rad t_rad_theRest];

elseif mirror && end_degree == 90 && num_channels == 2
    disp('mirrored about 90 degrees');
    mag_500_vectorL = [mag_500_vectorL fliplr(mag_500_vectorL) 
        fliplr([mag_500_vectorL fliplr(mag_500_vectorL)])];
    mag_1000_vectorL = [mag_1000_vectorL fliplr(mag_1000_vectorL)
        fliplr([mag_1000_vectorL fliplr(mag_1000_vectorL)])];
    mag_2000_vectorL = [mag_2000_vectorL fliplr(mag_2000_vectorL)
        fliplr([mag_2000_vectorL fliplr(mag_2000_vectorL)])];
    mag_4000_vectorL = [mag_4000_vectorL fliplr(mag_4000_vectorL)
         fliplr([mag_4000_vectorL fliplr(mag_4000_vectorL)])];
     
    mag_500_vectorR = [mag_500_vectorR fliplr(mag_500_vectorR) 
        fliplr([mag_500_vectorR fliplr(mag_500_vectorR)])];
    mag_1000_vectorR = [mag_1000_vectorR fliplr(mag_1000_vectorR)
        fliplr([mag_1000_vectorR fliplr(mag_1000_vectorR)])];
    mag_2000_vectorR = [mag_2000_vectorR fliplr(mag_2000_vectorR)
        fliplr([mag_2000_vectorR fliplr(mag_2000_vectorR)])];
    mag_4000_vectorR = [mag_4000_vectorR fliplr(mag_4000_vectorR)
         fliplr([mag_4000_vectorR fliplr(mag_4000_vectorR)])];
     
    t_rad_theRest1 = t_rad + index_end*interval*pi/180;
    t_rad_theRest2 = t_rad + 2*index_end*interval*pi/180;
    t_rad_theRest3 = t_rad + 3*index_end*interval*pi/180;
    t_rad = [t_rad t_rad_theRest1 t_rad_theRest2 t_rad_theRest3];

    
end;
    
if num_channels == 1
    
    all_magnitudes = [mag_500_vector(:) mag_1000_vector(:) mag_2000_vector(:) mag_4000_vector(:)];
    all_num_cols = size(all_magnitudes(1,:));
    t_rad_expander = ones(1, all_num_cols(2));
    t_rad_all = t_rad'*t_rad_expander;
    figure;
    h1 = polar(t_rad_all, all_magnitudes);
    set(h1,'LineWidth', 2);
    legend('4000 Hz', '2000 Hz', '1000 Hz', '500 Hz', 'Location', 'NorthEastOutside');

elseif num_channels == 2
    all_magnitudesL = [mag_500_vectorL(:) mag_1000_vectorL(:) mag_2000_vectorL(:) mag_4000_vectorL(:)];
    all_magnitudesR = [mag_500_vectorR(:) mag_1000_vectorR(:) mag_2000_vectorR(:) mag_4000_vectorR(:)];
    
    all_num_cols = size(all_magnitudesL(1,:));
    t_rad_expander = ones(1, all_num_cols(2));
    t_rad_all = t_rad'*t_rad_expander;
    figure;
    h1 = polar(t_rad_all, all_magnitudesL);
    set(h1,'LineWidth', 2);
    legend('4000 Hz', '2000 Hz', '1000 Hz', '500 Hz', 'Location', 'NorthEastOutside');
    title('polar response of Left channel');
    
    figure;
    h2 = polar(t_rad_all, all_magnitudesR);
    set(h2,'LineWidth', 2);
    legend('4000 Hz', '2000 Hz', '1000 Hz', '500 Hz', 'Location', 'NorthEastOutside');
    title('polar response of Right channel');

end;
